--- [정보처리기사 - 2020-3]

--- 01. 리팩토링의 목적에 대하여 서술하시오. ◆
	> 복잡한 코드의 단순화, 소스의 가독성을 통해 유지보수성 향상, 유연한 시스템, 생산성 향상, 품질 향상 등

--- 02. 다음은 C언어 소스 코드이다. 출력 결과를 쓰시오
	> void main() 
	  {
	      int i = 0; c = 0;
	      while (i<10)
	      {
	          i++;
		  c*= i;
	      }
	      print ("%d", c);
	  } 

	  - 0

--- 03. 대표적인 내부 라우팅 프로토콜로 다익스트라 알고리즘을 이용한 대규모 네트워크에 적합한 링크 상태 라우팅 프로토
	콜로 불리는 라우팅 프로토콜은 무엇인가? ◆
	> LSRP -> OSPF(Open Shortest Path First)

--- 04. 형상 통제를 설명하시오. ◆
	> 형상 항목의 버전 관리를 위해서 변경 여부와 변경 활동을 통제하는 활동

--- 05. 심리학자 톰 마릴은 컴퓨터가 메세지를 전달하고, 메세지가 제대로 도착했는지 확인하며, 도착하지 않았을 경우 메세
	지를 재전송하는 일련의 방법을 '기술적 은어'를 뜻하는 ( )이라는 용어로 정의했다. 괄호 ( )안에 들어갈 용어를 쓰
	시오.
	> 프로토콜

--- 06. TCP/IP에서 오류가 발생하면 (  ) 메세지를 보내서 오류가 발생했음을 알린다. 괄호(  ) 안에 들어갈 용어를 쓰시오.
	> ICMP(Internet Control Messgae Protocol)

--- 07. 다음 아래 제어 흐름 그래프가 분기 커버리지를 만족하기 위한 테스팅 순서를 쓰시오
	
	  ===========================================================================================================
	  ┌>	POINTER = FALSE	①
	  |
	  |		↓	②
	  |
	  |	X>K?				YES →	POINTER = TRUE	③
	  |
	  |		↓
	  |
	  ↑	X = X + 2	④
	  |	
	  |		↓
	  |
	  |	CALL SUB(X, POINTER, RESULT)	⑤
	  |
	  |		↓
	  |
	  |	RESULT > 1 ?	⑥	NO →	PRINT RESULT	⑦
	  |	
	  └---- ←	YES
	  ===========================================================================================================

	  - 1234561 / 124567 또는 1234567 / 124561

--- 08. 다음 조건을 만족하면서 과목별 점수의 평균이 90이상인 과목이름, 최소점수, 최대점수를 구하는 SQL문을 작성하시오
	> 대소문자를 구분하지 않는다.
	> WHERE 구분을 사용하지 않는다.
	> GROUP BY, HAVING 구문을 반드시 사용한다.
	> 세미콜론(;)은 생략 가능하다.
	> 별칭(AS)을 사용해야 한다.
	  ===========================================================================================================
	  [성적]
	  ===========================================================================================================
	  [과목코드]	[과목이름]	[학점]	[점수]
	  ===========================================================================================================
	  1000		컴퓨터과학	A+	95
	  2000		운영체제	B+	85
	  1000		컴퓨터과학	B+	85
	  2000		운영체제	B	80
	  ===========================================================================================================
	  ===========================================================================================================
	  [결과]
	  ===========================================================================================================
	  [과목이름]	[최소점수]	[최대점수]
	  ===========================================================================================================
	  컴퓨터과학	85		95
	  ===========================================================================================================

	  - SELECT 과목이름, MIN(성적) AS 최소점수, MAX(성적) AS 최대점수
	    FROM 성적
	    GROUP BY 과목이름
	    HAVING AVG(점수) >= 90;

--- 09. 학생 테이블에서 이름이 민수인 튜플을 삭제하는 SQL 문을 작성하시오
	> DELECT FROM 학생 WHERE 이름 = '민수';

--- 10. 릴레이션 A,B 가 있을 때 릴레이션 B 조건에 맞는 것들만 릴레이션 A에서 튜플을 꺼내 프로젝션 하는 관계 대수의 기
	호는 무엇인가? ◆
	> π -> ÷ 디비전

--- 11. 다음 중 헝가리안 표기법(Hungarian Case)에 대해서 서술하시오.
	> 접두어에 자료형의 명칭을 작성하는 명명규칙이다. 
          -> 식별자 표기 시 접두어에 자료형을 붙이는 표기법

--- 12. 테스트의 종류 중, 동치분할 테스트, 경계값 분석 테스트 등의 종류가 있는 테스트 기법을 쓰시오.
	> 블랙박스 테스트(명세 기반 테스트)

--- 13. 다음은 C언어 소스 코드이다. 출력 결과를 쓰시오.
	  ===========================================================================================================
	> int r1() { return 4; }
	  int r10() { return (30  + r1())};
	  int r100() { return (200 + r10())};
	  int main () { printf("%d\n", r100()); return 0;};
	  ===========================================================================================================

	  - 234
	
--- 14. DB 스키마에 대해서 서술하시오.
	> 데이터베이스의 구조, 정의에 대해 명세한 것으로 내부, 외부, 개념 스키마가 있다.
	  -> 데이터베이스의 구조, 제약조건 등의 정보를 담고 있는 기본적인 구조

--- 15. 다음은 자바 코드이다. 출력 결과를 쓰시오.
	  ===========================================================================================================
	> abstract class vehicle 
	  {
	      private String name;
	      abstract public String getName (String val);
	      public String getName()
	      {
	          return "vehicle name:" + name;
	      }
	      public void setName (String val)
	      {
		  name = val;
	      }
	  }

	  class Car extends Vehicle
	  {
	      public Car (String val) { setName(val);}
	
	      public String getName (String val) { return Car name : " + val;}
	      public String getName (byte val[]) { return Car name : " + val;}
	  }

	  public class good
	  {
	      public Static void main (String [] args)
	      {
		  Vehicle obj = new Car("Spark");
		  System.out.print(obj.getName());
	      }
	  }
	  ===========================================================================================================
	  - vehicle name:Spark

--- 16. UI 설계 원칙 중 직관성에 대해서 쓰시오 ◆
	> 사용자가 UI를 접할 때 한눈에 알아볼 수 있고 목적에 대해 직관적으로 알 수 있도록 설계하는 것.
	  -> 누구나 쉽게 이해하고, 쉽게 사용할 수 있어야 하고, 쉬운 검색, 쉬운 사용성, 일관성이 부 특성을 가지고 있는
	     UI 설계 원칙

--- 17. 다음은 자바 코드이다. 출력 결과를 쓰시오 ◆
	  ===========================================================================================================
	> public class good
	  {
	      public static void main(String[] args)
	      {
		  int i = 0;
		  int sum = 0;
		  while (i<10)
		  {
		      i++;
		      if(i%2 == 1)
		          continue;

		      sum += i;
		  }
	      }

	      System.out.println(sum);
	  } 
	  ===========================================================================================================

	  -   2 4 6 8 10 ==> 30
			
--- 18. EAI 유형에는 메세지 버스(Message bus), 하이브리드(Hybrid), (  ①  ), (  ②  ) 4가지가 있다.
	> ① 포인트 투 포인트(Point to Point)
	> ② 허브 앤 스포크(Hub and Spoke)

--- 19. C++ 에서 생성자란 무엇인지 쓰시오.
	> 특정 클래스의 (객체)인스턴스가 생성되었을 때 자동으로 호출되는 특수한 종류의 메소드

--- 20. 학생 테이블에 주소 속성을 추가하는 SQL 문을 작성하시오.
	> ALTER TABLE 학생 ADD 주소 VARCHAR(20);